10 CLS
20 FONT 2
30 LOCATE 15,0
40 PRINT "DUINOMITE-CANVIEW V4/BMS+ PRIUS G2";
50 LOCATE 20,20
60 REM PRINT "CANPORT OPEN";
70 REM declare variables for message reception
80 DIM rxId : DIM rxType : DIM rxLen : DIM rxData(8) : DIM rxOk
90 REM set CAN baudrate to 500 kbps and connect to the CAN bus
100 CANOPEN 500000
110 REM AUTO EV BUTTON - F1
120 FONT 1 : LOCATE 35,400 : PRINT "F1" : LOCATE 20,415 : PRINT "EV MAN ";
130 LINE(15,395)-(66,428),1,B
140 REM AUTO PHEV BUTTON - F4
150 FONT 1 : LOCATE 115,400 : PRINT "F4" : LOCATE 100,415 : PRINT "ORIG";
160 LINE(95,395)-(146,428),1,B
170 REM start the program loop
180 DO
190 REM quit program when user pressed 'q'
200 IF INKEY$ = "q" THEN EXIT
201 IF INKEY$ = CHR$(145) THEN GOSUB 10800 : REM F1
203 ENDIF
207 IF INKEY$ = CHR$(148) THEN GOSUB 10900 : REM F4
208 ENDIF
210 REM check if a message was received
220 CANRCV rxId, rxType, rxLen, rxData(0), rxOk
230 IF rxOk = 1 THEN 
240 REM process message data
250 REM PRINT VOLTAGE VALUE &H3B, BYTE 2.3
260 IF rxId = &H3B THEN Y = 65 : X = 360 : GOSUB 10330 : GOSUB 10080
270 FONT 2 : LOCATE 280,75 : PRINT "Volts:";
280 REM ************************************
290 REM PRINT THE AMPS VALUE &H3B, BYTE 0.1
300 IF rxId = &H3B THEN Y = 100 : X = 360 : GOSUB 10370 : GOSUB 10040
310 FONT 2 : LOCATE 293,110 : PRINT "Amps:";
320 REM ************************************
330 REM PRINT A-MAX VALUE &H3CB, BYTE 0
340 IF rxId = &H3CB THEN Y = 136 : X = 360 : GOSUB 10650 : GOSUB 10000
350 FONT 2 : LOCATE 280,146 : PRINT "A-MAX:";
360 REM ************************************
370 REM PRINT A+MAX VALUE &H3CB, BYTE 1 
380 IF rxId = &H3CB THEN Y = 172 : X = 360 : GOSUB 10040
390 FONT 2 : LOCATE 280,182 : PRINT "A+MAX:";
400 REM ************************************  
410 REM PRINT RPM VALUE &H3C8, BYTE 2
420 IF rxId = &H3C8 THEN Y = 212 : X = 360 : GOSUB 10450 : GOSUB 10080
430 FONT 2 : LOCATE 306,222 : PRINT "RPM:";
440 REM ************************************
450 REM PRINT TORQUE VALUE &H3C8, BYTE 3.4
460 IF rxId = &H3C8 THEN Y = 249 : X = 360 : GOSUB 10420 : GOSUB 10120
470 FONT 2 : LOCATE 319,258 : PRINT "NM:";
480 REM ************************************
490 IF rxId = &H3CB THEN Y = 286 : X = 360 : GOSUB 10490 : GOSUB 10120
500 FONT 2 : LOCATE 292,296 : PRINT "SOC%:";
510 REM ************************************
520 REM PRINT THROTTLE VALUE &H244, BYTE 6
530 IF rxId = &H244 THEN Y = 320 : X = 360 : GOSUB 10530 : GOSUB 10240
540 FONT 2 : LOCATE 266,330 : PRINT "THROT%:";
550 REM ************************************
560 REM PRINT ICE KW VALUE &H38, BYTE 1 
570 IF rxId = &H38 THEN Y = 356 : X = 360 : GOSUB 10570 : GOSUB 10040
580 FONT 2 : LOCATE 265,368 : PRINT "ICE KW:";
590 REM ************************************
600 REM PRINT BRAKE% VALUE &H30, BYTE 4 
610 IF rxId = &H30 THEN Y = 392 : X = 360 : GOSUB 10610 : GOSUB 10160
620 FONT 2 : LOCATE 264,400 : PRINT "BRAKE%:";
630 REM ************************************
640 IF rxId = &H3CD THEN Y = 260 : X = 120 : REM GOSUB 1000
650 IF rxId = &H3CF THEN Y = 280 : X = 120 :REM GOSUB 1000
660 IF rxId = &H484 THEN Y = 300 : X = 120 : REM GOSUB 1000
670 IF rxId = &H25 THEN Y = 320 : X = 120 : REM GOSUB 1000
680 IF rxId = &H540 THEN Y = 340 : X = 120 : REM GOSUB 1000
690 IF rxId = &H30 THEN Y = 360 : X = 120 : REM GOSUB 1000
700 IF rxId = &H230 THEN Y = 380 : X = 120 : REM GOSUB 1000
710 IF rxId = &hCB THEN Y = 400 : X = 120 : REM GOSUB 1000
9940 ENDIF
9950 LOOP
9960 CANCLOSE
9970 CLS
9980 PRINT "            CANPORT CLOSED"
9990 END
9999 REM ********* SUBROUTINES ***********
10000 REM PRINT BYTE 0 : FONT 3
10010 LOCATE X,Y : FONT 3
10020 PRINT FORMAT$(rxData(0),"% g");
10030 RETURN
10040 REM PRINT BYTE 1 : FONT 3
10050 LOCATE X,Y : FONT 3
10060 PRINT FORMAT$(RxData(1),"% g");
10070 RETURN
10080 REM PRINT BYTE 2 : FONT 3
10090 LOCATE X,Y : FONT 3
10100 PRINT FORMAT$(rxData(2),"% g");
10110 RETURN
10120 REM PRINT BYTE 3 : FONT 3
10130 LOCATE X,Y : FONT 3
10140 PRINT FORMAT$(rxData(3),"% .0f");
10150 RETURN
10160 REM PRINT BYTE 4 : FONT 3
10170 LOCATE X,Y : FONT 3
10180 PRINT FORMAT$(rxData(4),"% .0f");
10190 RETURN
10200 REM PRINT BYTE 5 : FONT 3
10210 LOCATE X,Y : FONT 3
10220 PRINT FORMAT$(rxData(5),"% g");
10230 RETURN
10240 REM PRINT BYTE 6 : FONT 3
10250 LOCATE X,Y : FONT 3
10260 PRINT FORMAT$(rxData(6),"% .0f");
10270 RETURN
10280 REM PRINT BYTE 7 : FONT 3
10290 LOCATE X,Y : FONT 3
10300 PRINT FORMAT$(rxData(7),"% g");
10310 RETURN
10320 REM ************************************
10330 REM TWO BYTE DATA, BYTE 2.3
10340 rxData(2) = rxData(2) * 256 + rxData(3) : REM VOLTS
10350 RETURN
10360 REM ************************************
10370 REM TWO BYTE DATA, BYTE 0.1 SIGNED
10380 rxData(1) = (rxData(1)/10) : REM TWO BYTE DATA SIGNED - AMPS
10390 IF rxData(0) = &H0 THEN rxdata(1) = rxData(1) * -1
10400 RETURN
10410 REM ************************************
10420 REM TWO BYTE DATA, BYTE 3.4
10430 rxData(3) = rxData(3) * 256 + rxData(4) : REM ICE/MG1 TORQUE NM
10440 RETURN
10450 REM ************************************
10460 REM BYTE DATA, BYTE 2 * (32REV/min)
10470 rxData(2) = rxData(2) * 32 : REM TWO BYTE DATA * (32REV/min) - RPM
10480 RETURN
10490 REM ************************************
10500 REM BYTE DATA, BYTE 3 / 2
10510 rxData(3) = rxData(3) / 2 : REM BYTE 3 DATA / 2 - SOC%
10520 RETURN
10530 REM ************************************
10540 REM BYTE DATA, BYTE 6 / 2
10550 rxData(6) = rxData(6) / 2 : REM BYTE 6 DATA / 2 - THROTTLE%
10560 RETURN
10570 REM ************************************
10580 REM BYTE DATA, BYTE 1 * 0.25
10590 rxData(1) = rxData(1) * 0.25 : REM BYTE 1 DATA * 0.25 - ICE KW
10600 RETURN
10610 REM ************************************
10620 REM BYTE DATA, BYTE 4 
10630 rxData(4) = (rxData(4)/127) * 100 : REM - BREAK%
10640 RETURN
10650 REM ************************************
10660 REM BYTE DATA, BYTE 0 X -1
10670 rxData(0) = rxData(0) * -1 : REM - A-MAX
10680 RETURN
10690 REM ************************************
10800 REM AUTO EV BUTTON FUNCTION R1 = RELAY 1 - CANVIEW V4 ONLY
10810 IF R1 = 0 THEN R1 = 1 ELSE R1 = 0
10820 FONT 1 : LOCATE 35,400 : PRINT "F1" : LOCATE 20,415 : PRINT "EV AUTO";
10830 IF R1 = 1 THEN LINE(15,395)-(66,428),1,B
10840 IF R1 = 0 THEN LOCATE 35,400 : PRINT "F1" : LOCATE 20,415 : PRINT "EV MAN ";
10860 RETURN
10900 REM PHEV/ORIG BUTTON FUNCTION R4 = RELAY 4 - CANVIEW V4 ONLY
10910 IF R4 = 0 THEN R4 = 1 ELSE R4 = 0
10920 FONT 1 : LOCATE 115,400 : PRINT "F4" : LOCATE 100,415 : PRINT "PHEV";
10930 IF R4 = 1 THEN LINE(95,395)-(146,428),1,B
10940 IF R4 = 0 THEN LOCATE 115,400 : PRINT "F4" : LOCATE 100,415 : PRINT "ORIG";
10960 RETURN
